grammar DFA;

/* Parser Rules */

start:       init production* final;

init:        (INIT EQUALS statename | );

production:  LEFT_PARENTHESIS statename COMMA statename RIGHT_PARENTHESIS EQUALS statename;

final:       FINAL EQUALS LEFT_BRACKET (statename (COMMA statename)* | ) RIGHT_BRACKET;

statename:   STATE;

/* Lexer Rules */

/* Tokens */

INIT              : 'init';
EQUALS            : '=';
LEFT_PARENTHESIS  : '(';
RIGHT_PARENTHESIS : ')';
LEFT_BRACKET      : '{';
RIGHT_BRACKET     : '}';
COMMA             : ',';
FINAL             : ('final');
STATE             : [a-zA-Z0-9]+;

/* Characters to be ignored */
WS : [ \r\t\n]+ -> skip ;
