grammar NFA;

/* Parser Rules */

start:       init production* final;

init:        (INIT EQUALS statename | );

production:  LEFT_PARENTHESIS statename COMMA (statename | EPSILON) RIGHT_PARENTHESIS EQUALS stateset;

stateset:    LEFT_BRACKET (statename (COMMA statename)* | ) RIGHT_BRACKET;

final:       FINAL EQUALS stateset;

statename:   STATE;

/* Lexer Rules */

/* Tokens */

INIT              : 'init';
EQUALS            : '=';
LEFT_PARENTHESIS  : '(';
RIGHT_PARENTHESIS : ')';
LEFT_BRACKET      : '{';
RIGHT_BRACKET     : '}';
COMMA             : ',';
FINAL             : ('final');
EPSILON           : ('ε' | '\\''e');
STATE             : [a-zA-Z0-9]+;

/* Characters to be ignored */
WS : [ \r\t\n]+ -> skip ;
