grammar RegEx;

/* Parser Rules */

start  : (expr | <EOF>);

expr   : concatenated+
       | expr CONCAT expr
       | expr UNION expr
       ;

concatenated: (symbol | (iterable (ITER | POS_ITER)) | parentheses);

iterable: (symbol | parentheses);

parentheses: LEFT_PAR expr RIGHT_PAR;

symbol : (ALPHABET | EPSILON | EMPTYSET);

/* Lexer Rules */

/* Tokens */

LEFT_PAR : '(';
RIGHT_PAR: ')';
ITER     : ('*' | '^*');
POS_ITER : '^+';
CONCAT   : '.';
UNION    : '+';
ALPHABET : [a-zA-Z0-9];
EPSILON  : ('ε' | '\\''e');
EMPTYSET : ('∅' | '\\''0');

/* Characters to be ignored */
WS : [ \r\t\n]+ -> skip ;
