

class Terminal:
    def __init__(self, name: str):
        self.name = name

    def __eq__(self, obj):
        if isinstance(obj, Terminal):
            return obj.name == self.name
        return False

    def __hash__(self):
        return hash(self.name)

    def __repr__(self) -> str:
        return f"Terminal({self.name})"


class Nonterminal:
    def __init__(self, name: str):
        self.name = name

    def __eq__(self, obj):
        if isinstance(obj, Nonterminal):
            return obj.name == self.name
        return False

    def __hash__(self):
        return hash(self.name)

    def __lt__(self, other) -> bool:
        return self.name < other.name

    def __repr__(self) -> str:
        return f"Nonterminal({self.name})"


class Character:
    def __init__(self, name: str):
        self.name = name

    def __eq__(self, obj):
        if isinstance(obj, Character):
            return obj.name == self.name
        return False

    def __hash__(self):
        return hash(self.name)


class State:
    def __init__(self, name: str):
        self.name = name

    def __eq__(self, obj):
        if isinstance(obj, State):
            return obj.name == self.name
        return False

    def __hash__(self):
        return hash(self.name)


class Eps:
    def __init__(self):
        self.name = "ε"

    def __eq__(self, other):
        return isinstance(other, Eps)

    def __hash__(self):
        return hash("ε")

    def __iter__(self):
        return iter(())

    def __len__(self):
        return 0


class Emptyset:
    def __init__(self):
        self.name = "∅"

    def __eq__(self, other):
        return isinstance(other, Eps)

    def __hash__(self):
        return hash("∅")
